{$R 'res\movie.res'}

unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FlashPlayerControl, StdCtrls, ShellApi;

type
  TMainForm = class(TForm)
    FlashPlayerControl1: TFlashPlayerControl;
    ButtonPlayFLV: TButton;
    OpenDialogFLV: TOpenDialog;
    ButtonPlaySWF: TButton;
    OpenDialogSWF: TOpenDialog;
    CheckBoxEnableStandartFlashMenu: TCheckBox;
    CheckBoxEnableSounds: TCheckBox;
    CheckBoxTransparent: TCheckBox;
    TransparentFlashPlayerControl1: TTransparentFlashPlayerControl;
    ButtonSite: TButton;
    ButtonOrder: TButton;
    procedure ButtonPlayFLVClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButtonPlaySWFClick(Sender: TObject);
    procedure CheckBoxEnableStandartFlashMenuClick(Sender: TObject);
    procedure CheckBoxEnableSoundsClick(Sender: TObject);
    procedure CheckBoxTransparentClick(Sender: TObject);
    procedure ButtonSiteClick(Sender: TObject);
    procedure ButtonOrderClick(Sender: TObject);
  private
    FFLVPath: String;
    FPlaySWF: Boolean;

    procedure OnGlobalLoadExternalResource(const URL: String; Stream: TStream);
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.ButtonPlayFLVClick(Sender: TObject);
var
  dwUsingFlashVersion: DWORD;
  ResourceStream: TResourceStream;
begin
  dwUsingFlashVersion := GetUsingFlashVersion;

  if (HIBYTE(HIWORD(dwUsingFlashVersion))) < 7 then
  begin
    ShowMessage(Format('The Sample needs Flash 7 or higher to play Flash Video' + #13 + 'Current version of Flash: %d.%d.%d.%d', [ HIBYTE(HIWORD(dwUsingFlashVersion)), LOBYTE(HIWORD(dwUsingFlashVersion)), HIBYTE(LOWORD(dwUsingFlashVersion)), LOBYTE(LOWORD(dwUsingFlashVersion)) ]));
    Exit;
  end;

  if OpenDialogFLV.Execute then
  begin
    FPlaySWF := False;

    FFLVPath := OpenDialogFLV.FileName;

    ResourceStream := TResourceStream.Create(0, 'FLVPlayer', 'FLASH');

    if FlashPlayerControl1.Visible then
      FlashPlayerControl1.PutMovieFromStream(ResourceStream)
    else
      TransparentFlashPlayerControl1.PutMovieFromStream(ResourceStream);

    ResourceStream.Free;
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  if Not IsFlashInstalled then
  begin
    ShowMessage('The application needs Flash'#13#10'Flash is not installed');
    Application.Terminate;
  end;

  SetGlobalOnLoadExternalResourceHandler(OnGlobalLoadExternalResource);

  OpenDialogFLV.InitialDir := ExtractFileDir(Application.ExeName);
  OpenDialogSWF.InitialDir := ExtractFileDir(Application.ExeName);

  CheckBoxEnableStandartFlashMenu.Checked := FlashPlayerControl1.StandartMenu;
  CheckBoxEnableSounds.Checked := FlashPlayerControl.GetAudioEnabled;

  CheckBoxTransparent.Checked := TransparentFlashPlayerControl1.Visible;

  FlashPlayerControl1.Movie := ExtractFileDir(Application.ExeName) + '\movie.swf';
  FlashPlayerControl1.Play;

  TransparentFlashPlayerControl1.Movie := ExtractFileDir(Application.ExeName) + '\movie.swf';
  TransparentFlashPlayerControl1.Play;

  FPlaySWF := True;
end;

procedure TMainForm.OnGlobalLoadExternalResource(const URL: String; Stream: TStream);
var
  FileStream: TFileStream;
  MemoryStream: TMemoryStream;
begin
  if URL = 'http://FLV/FlashVideo.flv' then
  begin
    if Length(FFLVPath) > 0 then
    begin
      FileStream := TFileStream.Create(FFLVPath, fmOpenRead);
      MemoryStream := TMemoryStream.Create;
      MemoryStream.LoadFromStream(FileStream);
      MemoryStream.SaveToStream(Stream);
      FileStream.Free;
      MemoryStream.Free;
    end;
  end;
end;

procedure TMainForm.ButtonPlaySWFClick(Sender: TObject);
begin
  if OpenDialogSWF.Execute then
  begin
    FPlaySWF := True;

    if FlashPlayerControl1.Visible then
    begin
      FlashPlayerControl1.Movie := OpenDialogSWF.FileName;
      FlashPlayerControl1.Play;
    end
    else
    begin
      TransparentFlashPlayerControl1.Movie := OpenDialogSWF.FileName;
      TransparentFlashPlayerControl1.Play;
    end;
  end;
end;

procedure TMainForm.CheckBoxEnableStandartFlashMenuClick(Sender: TObject);
begin
  FlashPlayerControl1.StandartMenu := CheckBoxEnableStandartFlashMenu.Checked;
  TransparentFlashPlayerControl1.StandartMenu := CheckBoxEnableStandartFlashMenu.Checked;
end;

procedure TMainForm.CheckBoxEnableSoundsClick(Sender: TObject);
begin
  FlashPlayerControl.SetAudioEnabled(CheckBoxEnableSounds.Checked);
end;

procedure TMainForm.CheckBoxTransparentClick(Sender: TObject);
var
  MoviePath: String;
  ResourceStream: TResourceStream;
begin
  FlashPlayerControl1.Visible := Not CheckBoxTransparent.Checked;
  TransparentFlashPlayerControl1.Visible := CheckBoxTransparent.Checked;

  if FPlaySWF then
  begin
    if FlashPlayerControl1.Visible then
    begin
      MoviePath := TransparentFlashPlayerControl1.Movie;

      if Length(MoviePath) > 0 then
      begin
        TransparentFlashPlayerControl1.Movie := '_';
        FlashPlayerControl1.Movie := MoviePath;
        FlashPlayerControl1.Play;
      end;
    end
    else
    begin
      MoviePath := FlashPlayerControl1.Movie;

      if Length(MoviePath) > 0 then
      begin
        FlashPlayerControl1.Movie := '_';
        TransparentFlashPlayerControl1.Movie := MoviePath;
        TransparentFlashPlayerControl1.Play;
      end;
    end;
  end
  else
  begin
    ResourceStream := TResourceStream.Create(0, 'FLVPlayer', 'FLASH');

    if FlashPlayerControl1.Visible then
      FlashPlayerControl1.PutMovieFromStream(ResourceStream)
    else
      TransparentFlashPlayerControl1.PutMovieFromStream(ResourceStream);

    ResourceStream.Free;
  end;
end;

procedure TMainForm.ButtonSiteClick(Sender: TObject);
begin
  ShellExecute(0, nil, 'http://www.flashplayercontrol.com/delphi/', nil, nil, SW_SHOW);
end;

procedure TMainForm.ButtonOrderClick(Sender: TObject);
begin
  ShellExecute(0, nil, 'http://www.flashplayercontrol.com/delphi/order.html', nil, nil, SW_SHOW);
end;

end.

